/**
 * 
 */
package jp.sourceforge.nicoro;

import java.lang.ref.SoftReference;
import java.util.Comparator;
import java.util.List;
import java.util.Random;

import android.graphics.Paint;
import android.util.Log;

/**
 * コメント (chat)
 */
public class MessageChat {
	private static final boolean DEBUG_LOGD = Release.IS_DEBUG && true;
	private static final String LOG_TAG = "NicoRo";
	
	// コメントカラー
	public static final int COLOR_WHITE = 0xFFFFFFFF;
	public static final int COLOR_RED = 0xFFFF0000;
	public static final int COLOR_PINK = 0xFFFF8080;
	public static final int COLOR_ORANGE = 0xFFFFCC00;
	public static final int COLOR_YELLOW = 0xFFFFFF00;
	public static final int COLOR_GREEN = 0xFF00FF00;
	public static final int COLOR_CYAN = 0xFF00FFFF;
	public static final int COLOR_BLUE = 0xFF0000FF;
	public static final int COLOR_PURPLE = 0xFFC000FF;
	public static final int COLOR_BLACK = 0xFF000000;
	public static final int COLOR_NICONICOWRITE = 0xFFCCCC99;
	public static final int COLOR_WHITE2 = COLOR_NICONICOWRITE;
	public static final int COLOR_TRUERED = 0xFFCC0033;
	public static final int COLOR_RED2 = COLOR_TRUERED;
	public static final int COLOR_PASSIONORANGE = 0xFFFF6600;
	public static final int COLOR_ORANGE2 = COLOR_PASSIONORANGE;
	public static final int COLOR_MADYELLOW = 0xFF999900;
	public static final int COLOR_YELLOW2 = COLOR_MADYELLOW;
	public static final int COLOR_ELEMENTALGREEN = 0xFF00CC66;
	public static final int COLOR_GREEN2 = COLOR_ELEMENTALGREEN;
	public static final int COLOR_MARINEBLUE = 0xFF33FFFC;
	public static final int COLOR_BLUE2 = COLOR_MARINEBLUE;
	public static final int COLOR_NOBLEVIOLET = 0xFF6633CC;
	public static final int COLOR_PURPLE2 = COLOR_NOBLEVIOLET;
	
	// コメント フォントサイズ
	public static final int FONTSIZE_PX_BIG = 39;
	public static final int FONTSIZE_PX_MEDIUM = 24;
	public static final int FONTSIZE_PX_SMALL = 15;
	
	// コメント 位置
	public static final int POS_NAKA = 0;
	public static final int POS_UE = 1;
	public static final int POS_SHITA = 2;
	
	/**
	 * コメント表示時間（10ms単位）
	 */
	public static final int DISPLAY_TIME_VPOS_NAKA = 400;
	public static final int DISPLAY_TIME_VPOS_UE = 300;
	public static final int DISPLAY_TIME_VPOS_SHITA = 300;
	
	private static final int TEXT_SIZE = 60 * 2;
	
	// XMLから設定するデータ
	private String mMail;
	public int vpos;
	public String text;
	
	public int line;

	private int mWidth;
	private float mSpeed;
	
	private int mColor;
	private int mFontSize;
	private int mPos;
	private boolean mInvisible = false;
	private float mX;
	private float mY;
	private int mVirtualY;
	
	public MessageChat(String m, int v) {
		mMail = m;
		vpos = v;
		
		boolean setColor = false;
		boolean setFontSize = false;
		boolean setPos = false;
		if (mMail != null) {
			String[] mails = mMail.split(" ");
			for (String s : mails) {
				if (s.startsWith("#")) {
					// 色
					if (!setColor) {
						mColor = 0xFF000000 | Integer.parseInt(s.substring(1), 16);
						setColor = true;
					}
				} else if (s.equals("white")) {
					if (!setColor) {
						mColor = COLOR_WHITE;
						setColor = true;
					}
				} else if (s.equals("red")) {
					if (!setColor) {
						mColor = COLOR_RED;
						setColor = true;
					}
				} else if (s.equals("pink")) {
					if (!setColor) {
						mColor = COLOR_PINK;
						setColor = true;
					}
				} else if (s.equals("orange")) {
					if (!setColor) {
						mColor = COLOR_ORANGE;
						setColor = true;
					}
				} else if (s.equals("yellow")) {
					if (!setColor) {
						mColor = COLOR_YELLOW;
						setColor = true;
					}
				} else if (s.equals("green")) {
					if (!setColor) {
						mColor = COLOR_GREEN;
						setColor = true;
					}
				} else if (s.equals("cyan")) {
					if (!setColor) {
						mColor = COLOR_CYAN;
						setColor = true;
					}
				} else if (s.equals("blue")) {
					if (!setColor) {
						mColor = COLOR_BLUE;
						setColor = true;
					}
				} else if (s.equals("purple")) {
					if (!setColor) {
						mColor = COLOR_PURPLE;
						setColor = true;
					}
				} else if (s.equals("black")) {
					if (!setColor) {
						mColor = COLOR_BLACK;
						setColor = true;
					}
				} else if (s.equals("niconicowhite")) {
					if (!setColor) {
						mColor = COLOR_NICONICOWRITE;
						setColor = true;
					}
				} else if (s.equals("white2")) {
					if (!setColor) {
						mColor = COLOR_WHITE2;
						setColor = true;
					}
				} else if (s.equals("truered")) {
					if (!setColor) {
						mColor = COLOR_TRUERED;
						setColor = true;
					}
				} else if (s.equals("red")) {
					if (!setColor) {
						mColor = COLOR_RED2;
						setColor = true;
					}
				} else if (s.equals("passionorange")) {
					if (!setColor) {
						mColor = COLOR_PASSIONORANGE;
						setColor = true;
					}
				} else if (s.equals("orange2")) {
					if (!setColor) {
						mColor = COLOR_ORANGE2;
						setColor = true;
					}
				} else if (s.equals("madyellow")) {
					if (!setColor) {
						mColor = COLOR_MADYELLOW;
						setColor = true;
					}
				} else if (s.equals("yellow2")) {
					if (!setColor) {
						mColor = COLOR_YELLOW2;
						setColor = true;
					}
				} else if (s.equals("elementalgreen")) {
					if (!setColor) {
						mColor = COLOR_ELEMENTALGREEN;
						setColor = true;
					}
				} else if (s.equals("green2")) {
					if (!setColor) {
						mColor = COLOR_GREEN2;
						setColor = true;
					}
				} else if (s.equals("marineblue")) {
					if (!setColor) {
						mColor = COLOR_MARINEBLUE;
						setColor = true;
					}
				} else if (s.equals("blue2")) {
					if (!setColor) {
						mColor = COLOR_BLUE2;
						setColor = true;
					}
				} else if (s.equals("nobleviolet")) {
					if (!setColor) {
						mColor = COLOR_NOBLEVIOLET;
						setColor = true;
					}
				} else if (s.equals("purple2")) {
					if (!setColor) {
						mColor = COLOR_PURPLE2;
						setColor = true;
					}
				} else if (s.equals("big")) {
					if (!setFontSize) {
						mFontSize = FONTSIZE_PX_BIG;
						setFontSize = true;
					}
				} else if (s.equals("medium")) {
					if (!setFontSize) {
						mFontSize = FONTSIZE_PX_MEDIUM;
						setFontSize = true;
					}
				} else if (s.equals("small")) {
					if (!setFontSize) {
						mFontSize = FONTSIZE_PX_SMALL;
						setFontSize = true;
					}
				} else if (s.equals("naka")) {
					if (!setPos) {
						mPos = POS_NAKA;
						setPos = true;
					}
				} else if (s.equals("ue")) {
					if (!setPos) {
						mPos = POS_UE;
						setPos = true;
					}
				} else if (s.equals("shita")) {
					if (!setPos) {
						mPos = POS_SHITA;
						setPos = true;
					}
				} else if (s.equals("invisible")) {
					mInvisible = true;
				} else if (s.equals("from_button")) {
					// TODO: 現状無視
				} else if (s.equals("is_button")) {
					// TODO: 現状無視
				} else if (s.equals("184")) {
					// 無視
				} else if (s.equals("sage")) {
					// 無視
				} else if (s.equals("docomo")) {
					// 無視
				} else {
					Log.d(LOG_TAG, "Unknown mail=" + s);
				}
				
				// TODO: ニコスクリプト
			}
		}
		
		if (!setColor) {
			mColor = COLOR_WHITE;
		}
		if (!setFontSize) {
			mFontSize = FONTSIZE_PX_MEDIUM;
		}
		if (!setPos) {
			mPos = POS_NAKA;
		}
	}
	
	@Override
	public String toString() {
		return "mail=" + mMail + " vpos=" + vpos + " text=" + text;
	}
	
	static private SoftReference<float[]> sComputeWidthBuffer = null;
	private static float[] getComputeWidthBuffer(final int textLength) {
		float[] buffer;
		if (sComputeWidthBuffer == null) {
			buffer = new float[Math.max(TEXT_SIZE, textLength)];
			sComputeWidthBuffer = new SoftReference<float[]>(buffer);
		} else {
			buffer = sComputeWidthBuffer.get();
			if (buffer == null) {
				buffer = new float[Math.max(TEXT_SIZE, textLength)];
				sComputeWidthBuffer = new SoftReference<float[]>(buffer);
			} else {
				if (buffer.length < textLength) {
					buffer = new float[textLength];
					sComputeWidthBuffer = new SoftReference<float[]>(buffer);
				}
			}
		}
		return buffer;
	}
	
	public void computeWidth(Paint paint) {
		if (text != null) {
			float[] widths = getComputeWidthBuffer(text.length());
			paint.setTextSize(mFontSize);
			int num = paint.getTextWidths(text, widths);
			float w = 0.0f;
			for (int i = 0; i < num; ++i) {
				w += widths[i];
			}
			mWidth = (int) w;
			if (mPos == POS_SHITA || mPos == POS_UE) {
				if (mWidth > AbstractNicoroPlayer.REAL_PLAYER_WIDTH_PX) {
					mFontSize = mFontSize * AbstractNicoroPlayer.REAL_PLAYER_WIDTH_PX / mWidth;
					mWidth = AbstractNicoroPlayer.REAL_PLAYER_WIDTH_PX;
				}
			}
		} else {
			mWidth = 0;
		}
	}
	
	public void computeSpeed() {
		switch (mPos) {
		case POS_NAKA:
			mSpeed = (float) -(AbstractNicoroPlayer.REAL_PLAYER_WIDTH_PX + mWidth)
			/ (float) MessageChat.DISPLAY_TIME_VPOS_NAKA;
			break;
		case POS_SHITA:
		case POS_UE:
			mSpeed = 0;
			break;
		default:
			assert false;
			mSpeed = (float) -(AbstractNicoroPlayer.REAL_PLAYER_WIDTH_PX + mWidth)
			/ (float) MessageChat.DISPLAY_TIME_VPOS_NAKA;
			break;
		}
	}
	
	public int getWidth() {
		return mWidth;
	}
	
	public int getColor() {
		return mColor;
	}
	public int getShadowColor() {
		if (mColor == COLOR_BLACK) {
			return 0xFF808080;
		} else {
			return 0xFF000000;
		}
	}
	
	public int getFontSize() {
		return mFontSize;
	}
	
	public float getSpeed() {
		return mSpeed;
	}
	
	public int getPos() {
		return mPos;
	}
	
	public int getStartX() {
		switch (mPos) {
		case POS_NAKA:
			return AbstractNicoroPlayer.REAL_PLAYER_WIDTH_PX;
		case POS_SHITA:
		case POS_UE:
			return (AbstractNicoroPlayer.REAL_PLAYER_WIDTH_PX - mWidth) / 2;
		default:
			assert false;
			return AbstractNicoroPlayer.REAL_PLAYER_WIDTH_PX;
		}
	}
	
	public float computeX(int vposCurrent) {
		mX = (float) getStartX() + mSpeed * (vposCurrent - vpos);
		return mX;
	}
	
	/**
	 * 
	 * @param y nakaまたはueなら上端、shitaなら下端に当たる座標
	 * @param paint
	 * @return 次のChatが表示されるY座標。nakaまたはueなら下端、shitaなら上端の座標
	 */
	public int setY(int y, Paint paint) {
		mVirtualY = y;
		paint.setTextSize(mFontSize);
		switch (mPos) {
		case POS_NAKA:
		case POS_UE:
			mY = y - paint.ascent();
			return mVirtualY + mFontSize;
		case POS_SHITA:
			mY = y - paint.descent();
			return mVirtualY - mFontSize;
		default:
			assert false;
			return y;
		}
	}
	
	public int getY() {
		return mVirtualY;
	}
	
	public int getNextY() {
		switch (mPos) {
		case POS_NAKA:
		case POS_UE:
			return mVirtualY + mFontSize;
		case POS_SHITA:
			return mVirtualY - mFontSize;
		default:
			assert false;
			return mVirtualY + mFontSize;
		}
	}
	
	public float getDrawY() {
		return mY;
	}
	
	public int computeShitaNextY(List<MessageChat> chats, Random random) {
		int nextY = AbstractNicoroPlayer.REAL_PLAYER_HEIGHT_PX_4_3;
		for (MessageChat shita : chats) {
			if ((nextY - (int) getFontSize()) >= shita.getY()) {
				break;
			}
			nextY = shita.getNextY();
		}
		if ((nextY - (int) getFontSize()) < 0) {
			// ランダム
			nextY = AbstractNicoroPlayer.REAL_PLAYER_HEIGHT_PX_4_3
			- random.nextInt(AbstractNicoroPlayer.REAL_PLAYER_HEIGHT_PX_4_3
					- (int) getFontSize());
		}
		return nextY;
	}
	
	public void addShitaOrder(List<MessageChat> chats) {
		int i = 0;
		for (MessageChat shita : chats) {
			if (getY() < shita.getY()) {
				++i;
			} else {
//				--i;
//				if (i < 0) {
//					i = 0;
//				}
				break;
			}
		}
		chats.add(i, this);
	}

	public int computeUeNextY(List<MessageChat> chats, Random random) {
		int nextY = 0;
		for (MessageChat ue : chats) {
			if ((nextY + (int) getFontSize()) <= ue.getY()) {
				break;
			}
			nextY = ue.getNextY();
		}
		if ((nextY + (int) getFontSize()) > AbstractNicoroPlayer.REAL_PLAYER_HEIGHT_PX_4_3) {
			// ランダム
			nextY = random.nextInt(AbstractNicoroPlayer.REAL_PLAYER_HEIGHT_PX_4_3
					- (int) getFontSize());
		}
		return nextY;
	}
	
	public void addUeOrder(List<MessageChat> chats) {
		int i = 0;
		for (MessageChat ue : chats) {
			if (getY() > ue.getY()) {
				++i;
			} else {
//				--i;
//				if (i < 0) {
//					i = 0;
//				}
    			break;
			}
		}
		chats.add(i, this);
	}

	public int computeNakaNextY(int vposCurrent, List<MessageChat> chats, Random random) {
		int nextY = 0;
		for (MessageChat naka : chats) {
			if ((nextY + (int) getFontSize()) <= naka.getY()) {
				float nakaXRight = naka.computeX(vpos + DISPLAY_TIME_VPOS_NAKA) + naka.getWidth();
				float thisXLeft = computeX(vpos + DISPLAY_TIME_VPOS_NAKA);
				if (nakaXRight < thisXLeft) {
					break;
				}
			}
			nextY = naka.getNextY();
		}
		if ((nextY + (int) getFontSize()) > AbstractNicoroPlayer.REAL_PLAYER_HEIGHT_PX_4_3) {
			// ランダム
			nextY = random.nextInt(AbstractNicoroPlayer.REAL_PLAYER_HEIGHT_PX_4_3
					- (int) getFontSize());
		}
		return nextY;
	}
	
	public void addNakaOrder(List<MessageChat> chats) {
		int i = 0;
		for (MessageChat naka : chats) {
			if (getY() > naka.getY()) {
				++i;
			} else {
//				--i;
//				if (i < 0) {
//					i = 0;
//				}
    			break;
			}
		}
		chats.add(i, this);
	}

	private static final Comparator<MessageChat> sVposComparator =
		new Comparator<MessageChat>() {
			@Override
			public int compare(MessageChat object1, MessageChat object2) {
				return object1.vpos - object2.vpos;
			}
		};
	public static Comparator<MessageChat> getVposComparator() {
		return sVposComparator;
	}
}